<?php
/**
 * Invision Power Services
 * IP.Board v3.0.1
 * 123flashchat Public
 *
 * @author 		$Author: TopCMM $
 * @copyright	(c) 2001 - 2010 TopCMM, Inc.
 * @license		http://www.invisionpower.com/community/board/license.html
 * @package		Invision Power Board
 * @subpackage	123flashchat
 * @link		http://www.123flashchat.com
 */

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

$ip_allowed = "";   // ip addresses delimited by comma, example: $ip_allowed='127.0.0.1, 192.168.0.1";
if (!empty($ip_allowed))
{
    $ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
    $ip_allowed_array = array_map('trim', explode(',', $ip_allowed));
    if (!in_array($ip,$ip_allowed_array))
    {
        exit();
    }
}

// 123 Flash Chat  Login Return Value
define('FC_LOGIN_SUCCESS',	0);
define('FC_LOGIN_ERROR_PASSWD', 1);
define('FC_LOGIN_ERROR', 3);
define('FC_LOGIN_ERROR_NOUSERID', 4);
define('FC_LOGIN_SUCCESS_ADMIN', 5);

class public_123flashchat_123flashchat_login_chat extends ipsCommand{
	private static $IPB_ADMIN_GROUP = array('4');
	/**
	 * Class entry point
	 *
	 * @access	public
	 * @param	object		Registry reference
	 * @return	void		[Outputs to screen/redirects]
	 */
	public function doExecute( ipsRegistry $registry ){
		if($this->request['username'] && $this->request['password']){
			if($member = $this->DB->buildAndFetch(array( 'select' => '*', 'from' => 'members', 'where' => "name='{$this->request['username']}'" ))){
				if ($this->request['password'] == $member['members_pass_hash']  or  IPSMember::generateCompiledPasshash( $member['members_pass_salt'], md5($this->request['password']) ) == $member['members_pass_hash']){
					$profile = '|eml='.$member['email'];
					if($member['bday_year'] && $member['bday_month'] && $member['bday_day']){
						$month =  ($member['bday_month'] >=10) ? $member['bday_month'] : '0'.$member['bday_month'];
						$day = ($member['bday_day'] >=10) ? $member['bday_day'] : '0'.$member['bday_day'];
						$profile .= '&a='.$member['bday_year'].$month.$day;
					}
					if($userinfo = $this->DB->buildAndFetch(array( 'select' => 'field_5 as sex,field_6 as location', 'from' => 'pfields_content', 'where' => "member_id=$member[member_id]" ))){
						if($userinfo['sex']){
							if($userinfo['sex'] == 'm'){
								$sex = 1;
							}elseif($userinfo['sex'] == 'f'){
								$sex = 2;
							}else{
								$sex = 0;
							}						
							$profile .= '&s='.$sex;
						}
						if($userinfo['location']){
							$profile .= '&l='.$userinfo['location'];
						}
					}
					if($userpic =  $this->DB->buildAndFetch(array( 'select' => 'pp_main_photo,pp_thumb_photo,pp_photo_type', 'from' => 'profile_portal', 'where' => "pp_member_id=$member[member_id]" ))){
						if($userpic['pp_photo_type'] == 'custom'){	//'gravatar','none','custom'
							$avatar = $this->settings['upload_url'].'/'.$userpic['pp_main_photo'];
							$profile .= '&avt='.$avatar.'&lckavt=1';
						}
						
					}			
					if(in_array($member['member_group_id'],self::$IPB_ADMIN_GROUP)){
						echo FC_LOGIN_SUCCESS_ADMIN.$profile;
					}else{
						echo FC_LOGIN_SUCCESS.$profile;
					}
				}else{
					echo FC_LOGIN_ERROR_PASSWD;
				}
			}
			else
			{
				echo FC_LOGIN_ERROR_NOUSERID;
			}
		}else{
			echo FC_LOGIN_ERROR;
		}
	
	}

}
